﻿AP730wc = {};

function AP730wc.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Baler, specializations);
end;

function AP730wc:load(xmlFile)
	self.extraAnim = SpecializationUtil.callSpecializationsFunction("extraAnim");
	self.extraChar = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.extraAnimations.extraAnimation(%d)", i);
		local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "#index"));
		if node == nil then
			break;
		end;
        self.extraChar[i+1] = node;
		i = i +1;
    end;
	self.extraClip = {};
	local i = 0;
    while true do
        local key = string.format("vehicle.extraAnimations.extraAnimation(%d)", i);
		local node = getXMLString(xmlFile, key.. "#animationClip");
		if node == nil then
			break;
		end;
        self.extraClip[i+1] = node;
		i = i +1;
    end;
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:delete()
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:onDetach()
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:mouseEvent(posX, posY, isDown, isUp, button)
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:keyEvent(unicode, sym, modifier, isDown)
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:update(dt)
	self:extraAnim();
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:updateTick(dt)
	if self:getIsActive() then
		for i, v in pairs(self.componentJoints) do
			setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
		end;
	end;
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:draw()
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:extraAnim()
	if self.isTurnedOn then
		local i=1;
		for i, v in pairs(self.extraChar) do
			local charId = getAnimCharacterSet(self.extraChar[i]);
			if charId == nil then
				break;
			end;
			local clipIndex = getAnimClipIndex(charId, self.extraClip[i]);
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, false);
			setAnimTrackSpeedScale(charId, 0, 5);
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) then
				setAnimTrackTime(charId, 0, 0, true);
			end;
		end;
	else
		if charID ~= nil then
			disableAnimTrack(charId, 0);
		end
	end
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	for i, v in pairs(self.componentJoints) do
		setJointFrame(self.componentJoints[i].jointIndex, 0, self.componentJoints[i].jointNode);
	end;
	
	return BaseMission.VEHICLE_LOAD_OK;
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:getSaveAttributesAndNodes(nodeIdent)
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:readStream(streamId, connection)
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:writeStream(streamId, connection)
end;
--________________________________________________________________________________________________________________________________________________________
function AP730wc:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
